package com.agiledeveloper;

public class FileMonitor
{
    private FileSystemChange theFileSystemChange;
    private Alarm theAlarm;

    public FileMonitor(FileSystemChange fileSystemChange, Alarm alarm)
    {
        theFileSystemChange = fileSystemChange;
        theAlarm = alarm;
    }

    public void monitor(String path)
    {
        theFileSystemChange.lookForChange(path);

        Thread th = new Thread(new Runnable()
        {
            public void run()
            {
                while (true)
                {
                    if (theFileSystemChange.hasChanged())
                    {
                        theAlarm.raise();
                    }

                    try
                    {
                        Thread.sleep(1000);
                    }
                    catch (InterruptedException e)
                    {
                        e.printStackTrace();
                    }
                }
            }
        }
        );

        th.setDaemon(true);
        th.start();
    }
}
